#include <stdio.h>
#include <stdlib.h>

#include "f2c.h"

 int main(void)
{
    /* Builtin functions */
    double sqrt(double), exp(double);
    /* Local variables */
    extern /* Subroutine */ int f_c();
    static double h__;
    static int m;
    static double y[2], h0;
    static int k0;
    static double dy[2], xk, xn, yn[2], yt[2], rab[839], dyn[2], dyt[2];
    int de79d_c( );
    static double dely[2];
    static int imax, ncheb;
    static double deldy[2], reldy[2];
    static int iniapr;
    static double relerr[2];

    m = 2;
    xn = 0.f;
    yn[0] = 1.;
    yn[1] = .5;
    dyn[0] = 0.;
    dyn[1] = 0.;
    h0 = .5;
    xk = sqrt(2.) * 3.;
    yt[0] = exp(xk * xk);
    yt[1] = exp(-xk * xk) * .5;
    dyt[0] = xk / yt[1];
    dyt[1] = -xk / yt[0];
    k0 = 15;
    imax = 28;
    for (iniapr = 1; iniapr <= 2; ++iniapr) {
	h__ = h0;
	ncheb = 0;

	de79d_c((U_fp)f_c, &m, &xn, yn, dyn, &xk, &k0, &iniapr, &imax, &h__, y,
		dy, rab);
	dely[0] = yt[0] - y[0];
	dely[1] = yt[1] - y[1];
	relerr[0] = dely[0] / yt[0];
	relerr[1] = dely[1] / yt[1];
	deldy[0] = dyt[0] - dy[0];
	deldy[1] = dyt[1] - dy[1];
	reldy[0] = deldy[0] / dyt[0];
	reldy[1] = deldy[1] / dyt[1];

    printf("\n h0=%21.14e k0=%3i iniapr= %1i imax=%3i \n\n",h0,k0,iniapr,imax);

    printf("\n y= %21.14e %21.14e\n",y[0],y[1]);
    printf("\n yt=%21.14e %21.14e\n",yt[0],yt[1]);
    printf("\n dely= %23.14e %23.14e \n", dely[0], dely[1]);
    printf("\n relerr= %21.14e %21.14e\n\n",relerr[0],relerr[1]);

    printf("\n dy= %21.14e %21.14e\n",dy[0],dy[1]);
    printf("\n dyt= %21.14e %21.14e\n",dyt[0],dyt[1]);
    printf("\n deldy= %23.14e %23.14e \n", deldy[0], deldy[1]);
    printf("\n reldy= %21.14e %21.14e\n\n",reldy[0],reldy[1]);

    printf("------------------------------------------------------\n" );
/* L42: */
    }
    return 0;
} /* main */

/* Subroutine */ int f_c(double *x, double *y, double *dy,
	double *z__, int *m)
{
    /* Parameter adjustments */
    --z__;
    --dy;
    --y;

    /* Function Body */
    z__[1] = 1. / y[2] + *x * *x / (y[1] * y[2] * y[2]);
    z__[2] = -1. / y[1] + *x * *x / (y[1] * y[1] * y[2]);
    return 0;
} /* f_c */
